from argparse import ArgumentParser
from test2 import xxd, run
from observe import ObservePackets


class TestWindowWidth(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestWindowWidth, self).__init__(ns, ctrl_file = ctrl_file)
        self.c2s = ns.c2s
        self.do_filter = False

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            return True
        if self.c2s == client_to_server and self.do_filter:
            print "**** DROPPED ****"
        else:
            self.send_all(dest, frame)

    def handle_ctrl(self):
        cmd = self.ctrl_file_read(10)
        if len(cmd) == 0:
            return False
        if cmd.startswith("go"):
            print "**** START FILTER ****"
            self.do_filter = True
        elif cmd.startswith("stop"):
            print "**** STOP FILTER ****"
            self.do_filter = False
        else:
            print "**** WTF ****"
        return True


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Window width test."
            )
    parser.add_argument(
            "--s2c",
            action = "store_false",
            dest = "c2s",
            default = True
            )
    parser.add_argument(
            "--c2s",
            action = "store_true",
            dest = "c2s"
            )
    run(TestWindowWidth, parser)


# EOF
