from argparse import ArgumentParser
from test2 import xxd, run
from observe import ObservePackets
import threading


class TestBreakUnique(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestBreakUnique, self).__init__(ns, ctrl_file = ctrl_file)
        self.break_ready = threading.Event()
        threading.Timer(6.0, self.break_now).start()

    def break_now(self):
        self.break_ready.set()

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            print "**** CONNECTION LOST ****"
            return True
        if self.break_ready.wait(0.0):
            print "**** BREAK CONNECTION ****"
            self.break_ready.clear()
            return True
        self.send_all(dest, frame)


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Unique connection break."
            )
    run(TestBreakUnique, parser)


# EOF
