from argparse import ArgumentParser
from test2 import xxd, run
from observe import ObservePackets
import threading


class TestRejectClosingInitiation(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestRejectClosingInitiation, self).__init__(ns, ctrl_file = ctrl_file)
        self.ready_to_reject = 0
        self.nb_rejected = 0

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            print "**** CONNECTION LOST ****"
            return True
        if not client_to_server:
            if '"retcode": 0}' in frame:
                # This is the last data frame.
                self.ready_to_reject = 1
        else:
            if self.ready_to_reject == 1:
                # This acks the last data frame.
                self.ready_to_reject = 2
            elif self.ready_to_reject == 2:
                if self.nb_rejected < 5:
                    print "**** REJECTED ({} YET) ****".format(self.nb_rejected + 1)
                    self.nb_rejected += 1
                    return False
        self.send_all(dest, frame)
        return False


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Unique connection break."
            )
    run(TestRejectClosingInitiation, parser)


# EOF
