from argparse import ArgumentParser
from test2 import xxd, run
from observe import ObservePackets
import threading


class TestBreakDuringClosing(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestBreakDuringClosing, self).__init__(ns, ctrl_file = ctrl_file)
        self.reject_reset = 2
        if ns.pass_on_auth:
            self.reject_reset = 1
        self.ready_to_reject = 0
        self.nb_break = 0

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            print "**** CONNECTION LOST ****"
            return True
        if not client_to_server:
            if '"retcode": 0}' in frame:
                # This is the last data frame.
                self.ready_to_reject = 1
        else:
            if self.ready_to_reject == 1:
                # This acks the last data frame.
                self.ready_to_reject = 2
            elif self.ready_to_reject == 2:
                if self.nb_break < 5:
                    print "**** PASS THEN BREAK ({} YET) ****".format(self.nb_break + 1)
                    self.send_all(dest, frame)
                    self.nb_break += 1
                    self.ready_to_reject = self.reject_reset
                    return True
        self.send_all(dest, frame)
        return False



if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Pass on bits of quit request, then break."
            )
    parser.add_argument(
            "--auth",
            action = "store_true",
            dest = "pass_on_auth",
            default = False
            )
    run(TestBreakDuringClosing, parser)


# EOF
