from argparse import ArgumentParser
from test2 import xxd, run
from observe import ObservePackets
import threading


class TestBreakDuringAuth(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestBreakDuringAuth, self).__init__(ns, ctrl_file = ctrl_file)
        self.pass_response = ns.pass_response
        self.pass_auth = False
        self.nb_data_passed = 0
        self.nb_breaks = 0
        self.pass_everything = False

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            print "**** CONNECTION LOST ****"
            return True
        if not self.pass_auth:
            if client_to_server:
                self.send_all(dest, frame)
                self.nb_breaks += 1
                if self.nb_breaks > 5:
                    print "**** LET GO AUTH ****"
                    self.pass_auth = True
                    self.nb_breaks = 0
                    return False
                return not self.pass_response
            else:
                self.send_all(dest, frame)
                return True
        if self.pass_everything:
            self.send_all(dest, frame)
            return False
        if self.nb_data_passed > 7:
            print "**** BREAK CONNECTION, REDO AUTH ****"
            self.pass_auth = False
            self.pass_everything = True
            return True
        self.send_all(dest, frame)
        if not client_to_server:
            self.nb_data_passed += 1
        return False

if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Break during authentication."
            )
    parser.add_argument(
            "--respond",
            action = "store_true",
            dest = "pass_response",
            default = False
            )
    run(TestBreakDuringAuth, parser)


# EOF
