import random
from argparse import ArgumentParser
from test2 import xxd, run
from observe import ObservePackets


class TestFrameReorder(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestFrameReorder, self).__init__(ns, ctrl_file)
        self.to_skip = 2
        self.resends = 0
        self.frame_buffer = []

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            return True
        if not client_to_server and "Line" in frame:
            if self.to_skip > 0:
                print "*** SKIPPING ***"
                self.to_skip -= 1
            else:
                if frame not in self.frame_buffer:
                    print "*** BUFFERING ***"
                    self.frame_buffer.append(frame)
                else:
                    self.resends += 1
                    if self.resends >= 10:
                        print "*** TOO MANY RESENDS! ***"
                        self.shuffle_and_forward(dest)
                    else:
                        print "*** RESEND: DROPPING ***"
                if len(self.frame_buffer) == 4:
                    self.shuffle_and_forward(dest)
                return False
        self.send_all(dest, frame)
        return False

    def shuffle_and_forward(self, dest):
        print "*** SENDING SHUFFLED FRAMES ({}) ***".format(len(self.frame_buffer))
        permut = list(xrange(0, 4))
        random.shuffle(permut)
        self.ctrl_file_write(repr(permut) + "\n")
        shuffled_frame = "".join(self.frame_buffer[n] for n in permut)
        xxd(shuffled_frame, self.group)
        self.send_all(dest, shuffled_frame)
        print "*** ALL SENT! ***"
        self.frame_buffer = []
        self.to_skip = 2
        self.resends = 0


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Frame reordering test."
            )
    run(TestFrameReorder, parser)


# EOF
