import random
from argparse import ArgumentParser
from test2 import xxd, run
from observe import ObservePackets


class TestDropFrames(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestDropFrames, self).__init__(ns, ctrl_file)
        self.nb_total = 0
        self.nb_dropped = 0

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            return True
        self.nb_total += 1
        if random.random() < 0.33:
            self.nb_dropped += 1
            print "*** DROP! dropped {}, total {} ***".format(
                    self.nb_dropped,
                    self.nb_total
                    )
        else:
            self.send_all(dest, frame)
        return False


if __name__ == "__main__":
    parser = ArgumentParser(
            description = "Frame dropping test."
            )
    run(TestDropFrames, parser)


# EOF
