import random
from argparse import ArgumentParser
from test2 import xxd, run
from observe import ObservePackets


class TestFrameDeliveredLate(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestFrameDeliveredLate, self).__init__(ns, ctrl_file)
        self.to_skip = 2
        self.frame_held = None

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            return True
        if not client_to_server and "Line" in frame:
            if self.to_skip > 0:
                self.to_skip -= 1
            else:
                if self.frame_held is None:
                    print "*** HOLD ***"
                    self.frame_held = frame
                    self.to_skip = 10
                    return False
                else:
                    print "*** RELEASE ***"
                    xxd(self.frame_held, self.group)
                    self.send_all(dest, self.frame_held)
                    self.frame_held = None
        self.send_all(dest, frame)
        return False


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Frame delivered late test."
            )
    run(TestFrameDeliveredLate, parser)


# EOF
