import random
from argparse import ArgumentParser
from test2 import xxd, run
from observe import ObservePackets
import time


class TestDropAcks(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestDropAcks, self).__init__(ns, ctrl_file)
        self.dropping = False
        self.timeout = time.time() + 1.0

    def handle_transfer(self, addr, src, dest, client_to_server):
        now = time.time()
        if now >= self.timeout:
            if self.dropping:
                print "*** FORWARDING ACKS ***"
                self.dropping = False
                self.timeout = now + 1.0
            else:
                print "*** DROPPING ACKS ***"
                self.dropping = True
                self.timeout = now + 3.0
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            return True
        if client_to_server and self.dropping:
            print "*** DROPPED ***"
        else:
            self.send_all(dest, frame)
        return False


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Dropping ACKs."
            )
    run(TestDropAcks, parser)


# EOF
