import random
from argparse import ArgumentParser
from test2 import xxd, run
from observe import ObservePackets
import time


class TestReinsertAcks(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestReinsertAcks, self).__init__(ns, ctrl_file)
        self.holding = False
        self.timeout = time.time() + 2.0
        self.acks_held = []

    def handle_transfer(self, addr, src, dest, client_to_server):
        now = time.time()
        if now >= self.timeout:
            if self.holding:
                print "*** FORWARDING ACKS ***"
                self.holding = False
                self.timeout = now + 1.0
            else:
                print "*** SENDING HELD ACKS ***"
                all_acks = "".join(self.acks_held)
                xxd(all_acks, self.group)
                self.send_all(dest, all_acks)
                self.acks_held = []
                print "*** HOLDING ACKS back ***"
                self.holding = True
                self.timeout = now + 3.0
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            return True
        if client_to_server and self.holding:
            print "*** HOLD! ***"
            self.acks_held.append(frame)
        else:
            self.send_all(dest, frame)
        return False


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Dropping ACKs."
            )
    run(TestReinsertAcks, parser)


# EOF

