from argparse import ArgumentParser
from observe import ObservePackets
import random
from test2 import xxd, run, nb_bytes_alter_variate, frame_has_distinct_body, frame_split, random_char


class TestAlterBodyBytes(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestAlterBodyBytes, self).__init__(ns, ctrl_file)
        self.nb_total = 0
        self.nb_altered = 0

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            return True
        if not client_to_server:
            self.nb_total += 1
        if (
                not client_to_server and
                frame_has_distinct_body(frame) and
                random.random() <= 0.4
                ):
            header_str, body, footer_str = frame_split(frame)
            header = list(header_str)
            footer = list(footer_str)
            nb_bytes_altered = nb_bytes_alter_variate(random)
            for n in random.sample(
                    xrange(0, len(header) + len(footer)),
                    nb_bytes_altered
                    ):
                if n >= len(header):
                    n -= len(header)
                    footer[n] = random_char(random)
                else:
                    header[n] = random_char(random)
            frame = "".join(header) + body + "".join(footer)
            self.nb_altered += 1
            print "*** ALTER {} BYTES | Altered {} / {} frames ***".format(
                    nb_bytes_altered,
                    self.nb_altered,
                    self.nb_total
                    )
            xxd(frame, self.group)
        self.send_all(dest, frame)
        return False


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Alter header bytes."
            )
    run(TestAlterBodyBytes, parser)


# EOF
