from argparse import ArgumentParser
from observe import ObservePackets
import random
from test2 import xxd, run


class TestTruncateFrames(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestTruncateFrames, self).__init__(ns, ctrl_file)
        self.nb_total = 0
        self.nb_truncated = 0

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            return True
        self.nb_total += 1
        if random.random() <= 0.4:
            new_len = random.randint(1, len(frame) - 1)
            frame = frame[0:new_len]
            self.nb_truncated += 1
            print "*** TRUNCATE TO {} BYTES | Truncated {} / {} frames ***".format(
                    new_len,
                    self.nb_truncated,
                    self.nb_total
                    )
            xxd(frame, self.group)
        self.send_all(dest, frame)
        return False


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Frame truncation."
            )
    run(TestTruncateFrames, parser)


# EOF
