from argparse import ArgumentParser
from observe import ObservePackets
import random
from test2 import xxd, run, garbage_str, frame_has_distinct_body, random_body_index


class TestInsertGarbageWithinFrames(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestInsertGarbageWithinFrames, self).__init__(ns, ctrl_file)
        self.nb_total = 0
        self.nb_altered = 0

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            return True
        if not client_to_server:
            self.nb_total += 1
        if (
                not client_to_server and
                frame_has_distinct_body(frame) and
                random.random() <= 0.4
                ):
            garbage = garbage_str(random, random.randint(2**12, 2**16 - 1))
            index = random_body_index(random, frame)
            frame = frame[0:index] + garbage + frame[index:]
            self.nb_altered += 1
            print "*** ALTER AT INDEX {} WITH {} BYTES OF GARBAGE ***".format(
                    index,
                    len(garbage)
                    )
            xxd(frame, self.group)
            print "*** Altered {} / {} frames ***".format(
                    self.nb_altered,
                    self.nb_total
                    )
        self.send_all(dest, frame)
        return False


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Insertion of garbage in frame."
            )
    run(TestInsertGarbageWithinFrames, parser)


# EOF
