from argparse import ArgumentParser
from observe import ObservePackets
import random
from test2 import xxd, run, garbage_str


class TestInsertGarbageBetweenFrames(ObservePackets):

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        garbage = garbage_str(random, int(random.expovariate(1.0 / 2048.0)))
        if client_to_server:
            print "*** FIRST PUSH {} BYTES OF GARBAGE TO SERVER ***".format(len(garbage))
        else:
            print "*** FIRST PUSH {} BYTES OF GARBAGE TO CLIENT ***".format(len(garbage))
        self.send_all(dest, garbage)
        if frame is None:
            return True
        self.send_all(dest, frame)
        return False


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Insertion of garbage between frames."
            )
    run(TestInsertGarbageBetweenFrames, parser)


# EOF
