from argparse import ArgumentParser
from observe import ObservePackets
import random
from test2 import xxd, run, nb_bytes_alter_variate, random_char


class TestAlterACKBytes(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestAlterACKBytes, self).__init__(ns, ctrl_file)
        self.nb_total = 0
        self.nb_altered = 0

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            return True
        if client_to_server:
            self.nb_total += 1
        if client_to_server and random.random() <= 0.4:
            nb_bytes_altered = min(nb_bytes_alter_variate(random), len(frame))
            frame_chars = list(frame)
            for n in random.sample(xrange(0, len(frame)), nb_bytes_altered):
                frame_chars[n] = random_char(random)
            frame = "".join(frame_chars)
            self.nb_altered += 1
            print "*** ALTER {} BYTES | Altered {} / {} frames ***".format(
                    nb_bytes_altered,
                    self.nb_altered,
                    self.nb_total
                    )
            xxd(frame, self.group)
        self.send_all(dest, frame)
        return False


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Alter ACK bytes."
            )
    run(TestAlterACKBytes, parser)


# EOF

