from argparse import ArgumentParser
from observe import ObservePackets
import random
from test2 import xxd, run, nb_bytes_alter_variate, frame_has_distinct_body, frame_split


class TestForceSentinelInBody(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestForceSentinelInBody, self).__init__(ns, ctrl_file)
        self.sentinel = ns.sentinel
        self.nb_total = 0
        self.nb_altered = 0

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            return True
        if not client_to_server:
            self.nb_total += 1
            if frame_has_distinct_body(frame) and random.random() <= 0.4:
                header, body, footer = frame_split(frame)
                index_start = random.randint(0, len(body) - len(self.sentinel))
                index_after = index_start + len(self.sentinel)
                frame = (
                        header +
                        body[0:index_start] +
                        self.sentinel +
                        body[index_after:] +
                        footer
                        )
                self.nb_altered += 1
                print "*** INSERT SENTINEL | Altered {} / {} frames ***".format(
                        self.nb_altered,
                        self.nb_total
                        )
                xxd(frame, self.group)
        self.send_all(dest, frame)
        return False


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Sentinel forced into body."
            )
    parser.add_argument(
            "-s sentinel",
            dest = "sentinel",
            help = "Sentinel to insert."
            )
    run(TestForceSentinelInBody, parser)


# EOF
