from argparse import ArgumentParser
from observe import ObservePackets
import random
from test2 import xxd, run

from frames import Frame

class TestRemoveDataFromDataFrame(ObservePackets):

    def __init__(self, ns, ctrl_file):
        super(TestRemoveDataFromDataFrame, self).__init__(ns, ctrl_file)
        self.nb_total = 0
        self.nb_altered = 0

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = Frame.recv(src)
        if frame is None:
            print "*** {} CLOSING ***".format("CLIENT" if client_to_server else "SERVER")
            return True
        print "*** FROM {} ***".format("CLIENT" if client_to_server else "SERVER")
        if frame.length is not None:
            self.nb_total += 1
            if random.random() <= 0.4:
                self.nb_altered += 1
                frame.length = 0
                frame.data = ""
                print "*** REMOVE ALL DATA | Altered {}, total {} ({:.1f}%) ***".format(
                        self.nb_altered,
                        self.nb_total,
                        100.0 * float(self.nb_altered) / float(self.nb_total)
                        )
        relayed = frame.send(dest)
        xxd(relayed, self.group)
        return False


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Removing data from data frames."
            )
    run(TestRemoveDataFromDataFrame, parser)


# EOF
