import socket

class Error(Exception):
    pass

def recv(sock, n):
    try:
        r = ""
        while len(r) < n:
            chunk = sock.recv(n - len(r))
            if len(chunk) == 0:
                raise Error()
            r += chunk
        return r
    except socket.error:
        raise Error()

def send(sock, s):
    try:
        while len(s) > 0:
            n = sock.send(s)
            if n == 0:
                raise Error()
            s = s[n:]
    except socket.error:
        raise Error()


#EOF
