import argparse
import sys
import time

parser = argparse.ArgumentParser(
        description = "Line printer"
        )
parser.add_argument(
        "nb_lines",
        type = int,
        help = "Number of lines."
        )
parser.add_argument(
        "-b sleep_time",
        dest = "before",
        type = float,
        help = "Sleep time before all lines.",
        default = 0.0
        )
parser.add_argument(
        "-s sleep_time",
        dest = "sleep_time",
        type = float,
        help = "Sleep time between lines.",
        default = 0.2
        )
parser.add_argument(
        "-a start_line",
        dest = "start_line",
        type = int,
        help = "Starting line number.",
        default = 1
        )
ns = parser.parse_args(sys.argv[1:])

if ns.before > 0.0:
    print "Sleeping {:.1f} seconds before starting...".format(ns.before)
    time.sleep(ns.before)
for n in xrange(ns.start_line - 1, ns.start_line - 1 + ns.nb_lines):
    print "Line", n+1
    time.sleep(ns.sleep_time)


# EOF
