from argparse import ArgumentParser
import os.path
import sys
from test2 import xxd

sys.path.append(
        os.path.abspath(os.path.join(os.path.dirname(__file__), "..", "mitm"))
        )
from mitm import ManInTheMiddle, run


class ObservePackets(ManInTheMiddle):

    def __init__(self, ns, ctrl_file):
        super(ObservePackets, self).__init__(ns, ctrl_file = ctrl_file)
        self.group = 4
        if hasattr(ns, "group"):
            self.group = ns.group

    def catch_frame(self, src, client_to_server):
        data = src.recv(4096)
        if len(data) == 0:
            if client_to_server:
                print "**** Client closing ****"
            else:
                print "**** Server closing ****"
            return None
        else:
            if client_to_server:
                print "**** From client ****"
            else:
                print "**** From server ****"
            xxd(data, self.group)
            return data

    def handle_transfer(self, addr, src, dest, client_to_server):
        frame = self.catch_frame(src, client_to_server)
        if frame is None:
            return True
        self.send_all(dest, frame)
        return False


if __name__ == '__main__':
    parser = ArgumentParser(
            description = "Packet observer with binary disassembly."
            )
    parser.add_argument(
            "-g GROUP",
            dest = "group",
            type = int,
            help = "Byte grouping in XXD packet dump.",
            default = 2
            )
    run(ObservePackets, parser)


# EOF
