import os
import tarfile
import zipfile

def unarchive(arch, subdir):
    parent = os.path.dirname(subdir)
    base = os.path.basename(subdir)
    if not os.path.isdir(parent):
        os.makedirs(parent)
    if arch.endswith(".zip"):
        try:
            with zipfile.ZipFile(arch) as zf:
                zf.extractall(parent)
        except:
            print "Erreur -- Extraction de l'archive Zip {} impossible.".format(arch)
    elif arch.endswith(".tar.gz"):
        try:
            with tarfile.open(arch, "r:gz") as tf:
                tf.extractall(parent)
        except:
            print "Erreur -- Extraction de l'archive Tar/Gzip {} impossible.".format(arch)
    else:
        print "Erreur -- Format d'archive non supporte: {}".format(os.path.basename(arch))
    if os.path.isdir(os.path.join(parent, "tp1")):
        os.rename(os.path.join(parent, "tp1"), subdir)
    else:
        print "Erreur -- truc extrait ne s'appelle pas 'tp1'."
        print os.listdir(parent)

def prepare_code(subdir):
    resh_text = None
    for name in ["resh", "reshd", "ltee", "lcat"]:
        resh_path = os.path.join(subdir, name)
        if os.path.exists(resh_path):
            pass
        elif os.path.exists(resh_path + ".py"):
            print "{}: installation du lanceur {}.".format(subdir, name)
            with open(resh_path, "w") as resh_file:
                resh_file.write(
                        "#!/bin/bash\npython -u `dirname $0`/{}.py $@\n".format(
                            os.path.basename(resh_path)
                            )
                        )
        else:
            print "{}: no {} file".format(subdir, name)
            continue
        os.chmod(resh_path, 0755)


for path in os.listdir("."):
    if path.endswith(".tar.gz") or path.endswith(".zip"):
        base, _ = os.path.splitext(os.path.splitext(path)[0])
        os.makedirs(base)
        for subp in [os.path.join(base, s) for s in ["client", "serveur"]]:
            unarchive(path, subp)
            prepare_code(subp)
        os.remove(path)


# EOF
